/**
 * This is an interface for a Queue ADT.
 * 
 * @author David J. Nickles
 * @version $ID$
 */

public interface Queue {

  // Accessor methods:

  /**
   * This method returns true if the queue empty, false if it is not.
   * 
   * @return boolean state of emptiness of the queue.
   */
  public boolean empty();

  /**
   * This method returns an integer value of the number of items currently
   * residing in the queue.
   * 
   * @return a count of the items in the queue.
   */
  public int size();

  /**
   * Return the object at the front of the queue (without changing the queue).
   * @return the object in the front of the queue.
   * @throws QueueEmptyException
   */
  public Object front() throws QueueEmptyException;

  // Mutator methods:

  /**
   * Insert an objet into the queue.
   * @param object The object to add to the queue.
   * @throws QueueFullException
   */
  public void enqueue(Object object) throws QueueFullException;

  /**
   * Remove and return the object at the front of the queue.
   * @return an object that has been removed from the front of the queue.
   * @throws QueueEmptyException
   */
  public Object dequeue() throws QueueEmptyException;
}